import {Injectable} from "@angular/core";
import {HttpClient} from '@angular/common/http';
import {HttpDataSourceOptionsBuilder} from "./HttpDataSourceOptionsBuilder";
import {SingleDataSourceOptionsBuilder} from "./SingleObjectDataSourceBuilder";
import {ListDataSourceOptionsBuilder} from "./ListDataSourceBuilder";
import {IQueryCriteria} from "@openharbor/data";


@Injectable({
  providedIn: 'root'
})
export class HttpDataSourceService {
  constructor(private http: HttpClient) {
  }

  builder<TQuery extends IQueryCriteria, TModel extends {}>() {
    return new HttpDataSourceOptionsBuilder<TQuery, TModel>(this.http);
  }

  singleBuilder<TQuery extends IQueryCriteria, TModel extends {}>() {
    return new SingleDataSourceOptionsBuilder<TQuery, TModel>(this.http);
  }

  listBuilder<TQuery extends IQueryCriteria, TModel extends {}>() {
    return new ListDataSourceOptionsBuilder<TQuery, TModel>(this.http);
  }
}
